#include "mqueue.h"
typedef enum {xplane, yplane, zplane} dimension;

void move_arm(dimension D, int P);

/* have screwed up this file! */
#define DEFAULT_NBYTES 1
int nbytes = DEFAULT_NBYTES;

#define MQ_IN1  "/mq_in1"
#define MQ_IN2  "/mq_in2"
#define MQ_IN1  "/mq_in3"
#define MQ_OUT1  "/mq_out1"
#define MQ_OUT2  "/mq_out2"
#define MQ_SWICHT  "/mq_swicth"

void controller(dimension dim) 
{
  int position, setting;
  mqd_t my_queue;
  struct mq_attr ma;
  int err;
  char buf[DEFAULT_NBYTES];

  position = 0;
  while (1) {
    switch(dim) {
      case xplane: 
        if (( my_queue = mq_open(MQ_XPLANE, O_RDONLY, MODE, &ma)) < 0) {
          /* indicate error */
          exit(1);
        }
      case yplane: 
        if (( my_queue = mq_open(MQ_YPLANE, O_RDONLY, MODE, &ma)) < 0) {
          /* indicate error */
          exit(1);
        }
      case zplane: 
        if (( my_queue = mq_open(MQ_ZPLANE, O_RDONLY, MODE, &ma)) < 0) {
          /* indicate error */
          exit(1);
        }
      default:
          exit(2);
    };
    if((err = mq_receive(my_queue, &buf[0], nbytes, 0)) < 0) {
          exit(3);
    };
    setting = (int) (&buf[0]);
    position = position + setting;
    move_arm(dim, position);
  };
}

void (*C)(dimension dim) = &controller;

int main(int argc, char **argv) {
  mqd_t mq_xplane, mq_yplane, mq_zplane; /* one queue for each process */
  struct mq_attr ma; /* queue attributes */
  int xpid, ypid, zpid;
  int err;
  char buf[DEFAULT_NBYTES];

    /* set message queues attributes*/
    ma.mq_flags = 0;    /* No special behavior */
    ma.mq_maxmsg = 1;
    ma.mq_msgsize = nbytes;

    if (( mq_xplane = mq_open(MQ_XPLANE, O_CREAT|O_EXCL, MODE, &ma)) < 0) {
        /* indicate error */
        exit(1);
    };
    if (( mq_yplane = mq_open(MQ_YPLANE, O_CREAT|O_EXCL, MODE, &ma)) < 0) {
        /* indicate error */
        exit(1);
    };
    if (( mq_zplane = mq_open(MQ_ZPLANE, O_CREAT|O_EXCL, MODE, &ma)) < 0) {
        /* indicate error */
        exit(1);
    };

    /* Duplicate the process to get the three controllers */
    switch (xpid = fork()) {
        case -1:    /* error */
                exit(2);
                break;
        case 0:     /* child */
                controller(xplane);
                exit(0);
                break;
        default:    /* parent */
   	    switch (zpid = fork()) {
                case -1:    /* error */
                    exit(2);
                    break;
            case 0:     /* child */
                controller(yplane);
                exit(0);
                break;
            default:    /* parent */
   	        switch (zpid = fork()) {
                   case -1:    /* error */
                        exit(2);
                        break;
                case 0:     /* child */
                    controller(yplane);
                    exit(0);
                    break;
                default:    /* parent */
                    break;
            }
        }
    }

  
  while (1) {
    /* find new position and set up buffer to transmit each
       co-ordinate to the controllers, for example */
    if((err = mq_send(mq_xplane, &buf[0], nbytes, 0)) < 0) {
      exit(3);
    };
  }
}
