typedef mqd_t ;
typedef mode_t;
typedef size_t;

struct mq_attr {
  long mq_flags;
  long mq_maxmsg;
  long mq_msgsize;
  long mq_curmsg;
};

/* struct mq_atr fred; */

#define O_CREAT 1
#define O_EXCL 2
#define O_RDONLY 3
#define MODE 777
int mq_getattr(mqd_t mq, struct mq_attr *attrbuf);
  /* get the current attributes associated with mq */
int mq_setattr(mqd_t mq, const struct mq_attr *new_attrs,
               struct mq_attr *old_attrs);
  /* set the current attributes associated with mq */

mqd_t mq_open(char *mq_name, int oflags, mode_t mode, 
              struct mq_attr *mq_attr);
  /* open/create the named message queue */

int mq_close(mqd_t mq);
  /* close the message queue */

int mq_unlink(const char *mq_name);

int mq_receive(mqd_t mq, char *msq_buffer, 
               size_t buflen, unsigned int *msgprio);
  /* get the next message in the queue and store it in the 
     area pointed at by msq_buffer */

int mq_send(mqd_t mq, const char *msq, 
               size_t msglen, unsigned int msgprio);
  /* send the message pointed at by msq */


int mq_notify(mqd_t mq, const struct sigevent *notification);
  /* request that a signal be sent to the calling process
     if a message arrives on an empty mq and there are no 
     waiting receivers */





