procedure Operator is
  -- the following declarations are purely so the example compiles
  type Number is new integer;
  type Name is new Integer;
  type Address is new Integer;
  type Postal_Code is new Integer;
  Unallocated_Faults : Boolean;
  
  task type Telephone_Operator is
    entry Directory_Enquiry(Person : in  Name; Addr : in Address;
                          Num : out Number);

    entry Directory_Enquiry(Person : in  Name; 
        ZIP : in Postal_Code; Num : out Number);

    entry Report_Fault(Num : Number);
private
  entry Allocate_Repair_Worker(Num : out Number);
end Telephone_Operator;

  task body Telephone_Operator is
    Workers : constant integer := 10;
    Failed : Number;
    task type Repair_Worker;
    Work_Force : array (1 .. Workers) of Repair_Worker;
    task body Repair_Worker is begin null; end;
  begin
    loop
      -- prepare to accept next request
      select
        accept Directory_Enquiry(Person : in  Name; 
             Addr : in Address; Num : out Number) do
          -- look up telephone number and 
          -- assign the value to Num
          null;
        end Directory_Enquiry;
      or
        accept Directory_Enquiry(Person : in  Name; 
             ZIP : in Postal_Code; Num : out Number) do
          -- look up telephone number and 
          -- assign the value to Num
          null;
        end Directory_Enquiry;
      or
        accept Report_Fault(Num : Number) do
          Failed := Num;
        end Report_fault;
        -- store failed number
      or
        when Unallocated_Faults =>
          accept Allocate_Repair_Worker(Num : out Number) do
            -- get next failed number
            NUM := 6; -- ...
          end Allocate_Repair_Worker;
        -- update record of failed unallocated numbers
      or
        terminate;
      end select;
 
    end loop;
  end Telephone_Operator;
begin
  null;
end Operator;
